
(in-package :custom)
(use-package '(:frame2 :frame2-ui :ui :uib :elan :k2))

;; :custom is a new package => use it in SolidDesigners default package
(use-package :custom :mei)

(export '(rohr-aus-tabelle))

;;----- Globale Variablen ------------------------------------------------------

(defvar *rohrdat-filename*)
(setf *rohrdat-filename* "rohr.dat")

(defvar *rohrwandstaerke*)
(setf *rohrwandstaerke* 0.5)

;;=============================================================================

(defun rohr-aus-tabelle ()
  (let ((error nil)
	file-stream
	)

; Erzeugen eines Hilfskrpers fr sptere Durchdringungsmenge
	(create_workplane :new :name "REST")
	(RECTANGLE 100,100 100.1,100.1)
	(extrude :part "/ROHR_REST" :distance 0.1 :keep_wp :no)

; Setzen von globalen Variablen und Zhlern
      (setq AE-Leitkurve-Zaehler 1)
;      (setq *rohr-filename* "rohr.dat")

	(create_wpset :name "AES_Leitkurve")

; Lesen der Punkte- und Biegeradien-Datei :
      (setq file-stream (open *rohrdat-filename* :direction :input))
       (setq wert_x_p1 (read file-stream nil 'eof))
       (setq wert_y_p1 (read file-stream nil 'eof))
       (setq wert_z_p1 (read file-stream nil 'eof))
       (setq p1 (gpnt3d wert_x_p1 wert_y_p1 wert_z_p1))

       (setq radius (read file-stream nil 'eof))

       (setq wert_x_p1 (read file-stream nil 'eof))
       (setq wert_y_p1 (read file-stream nil 'eof))
       (setq wert_z_p1 (read file-stream nil 'eof))
       (setq p2 (gpnt3d wert_x_p1 wert_y_p1 wert_z_p1))

       (setq radius (read file-stream nil 'eof))

     (loop

       (setq wert_x_p1 (read file-stream nil 'eof))
       (when (eq wert_x_p1 'eof) (return))
       (setq wert_y_p1 (read file-stream nil 'eof))
       (when (eq wert_y_p1 'eof) (return))
       (setq wert_z_p1 (read file-stream nil 'eof))
       (when (eq wert_z_p1 'eof) (return))
       (setq p3 (gpnt3d wert_x_p1 wert_y_p1 wert_z_p1))


;; Alle Daten sind eingelesen fuer ein Rohrabschnitt (2x Gerade mit Bogen)
   ;; Berechnung :
       (create-rohr  radius p1 p2 p3 *rohrdurchmesser_halb*)
       
;; Die Teilabschnitte werden vereint bzw umbenannt zur weiteren Bearbeitung.
       (intersect_3d :blanks "/R1" :tools "/ROHR_REST" :keep_tool :no)
       (unite_3d :blank "/R1" :tools  "/R2" :keep_tools :no)
       (change_pa_name "/R1" "ROHR")
       (change_pa_name "/R3" "ROHR_REST")
       (unite_3d :blank "/ROHR_GESAMT" :tools  "/ROHR" :keep_tools :no)

;; Die Leitkurven-Arbeitsebene wird umbenannt, damit sie erhalten werden kann.
       (change_wp_name "/AE_Leitkurve" (format nil "AE_Leitkurve~A" AE-Leitkurve-Zaehler ))
       (setq AE-Leitkurve-Zaehler (+ AE-Leitkurve-Zaehler 1))
;; Die bisherigen Punkte werden um eins verschoben :
       (setq p1 p2)
       (setq p2 p3)

;  Der Radius ist immer von dem mittleren Wert p2 massgebend!
       (setq radius (read file-stream nil 'eof))
       (when (eq radius 'eof) (return))

       )
      (close file-stream)
      (update-screen)
      ;;--------------------------------------
    
;; Der letzte Rohr-Rest wird mit dem Gesamtrohr vereint.
       (unite_3d :blank "/ROHR_GESAMT" :tools  "/ROHR_REST" :keep_tools :no)

;; Die einzelnen Arbeitsebeneen der Leitkurve werden zusammengefat.
       (change_wp_owner :new_owner "/AES_Leitkurve" :workplanes :all_at_top)

;; Das Gesamtrohr wird innen mit der Wandstrke mit Hilfe der Schalenfunktion ausgehhlt.
   (current_part "/ROHR_GESAMT")
   (shell_3d :offset *rohrwandstaerke* :open_face :start :current_part :plane :all_3d :select_done)

    (hide-dialog "ROHRDAT")
    (hide-file-browser :implicit nil)

))

;;*****************************************************************************
;;*****************************************************************************
;;*****************************************************************************

(in-package :custom)
(use-package '(:frame2 :frame2-ui :ui :uib :elan :k2))

;; :custom is a new package => use it in SolidDesigners default package
(use-package :custom :mei)


(export '(dateiname-toggle-pushed
	  rohrdurch-pushed
	  wandst-pushed))

;;----- global variables ------------------------------------------------------

(defvar *rohrdat-filename*)

;;----- Create the User Interface ---------------------------------------------

(create-right-menu-dialog "ROHRDAT"         ;; Name of Dialog
			  "Rohr aus Datei"  ;; Toplabel
   '(
     (:heterogeneous  "ROHRDAT-OPTIONS"
      (
       (:toggle-data "FILENAME"
		     "Dateiname"
		     :filename
		     :half
		     "(dateiname-toggle-pushed)"  ;; this has to go through
		     ;; the Input Buffer, because the function requires
		     ;; data interactively !
		     :cancel-and-restart-command
		     (dateiname-return)  ;; direct LISP function call
		     t
       )
       (:toggle-data "ADURCH"
		     "Auen-"
		     :length
		     :half
		     "(rohrdurch-pushed)"
		     :cancel-and-restart-command
		     (rohrdurch-return)
		     t
       )
       (:toggle-data "WANDST"
		     "Wandstrke"
		     :length
		     :half
		     "(wandst-pushed)"
		     :cancel-and-restart-command
		     (wandst-return)
		     t
       )
       (:separator "SEPARATOR")
       (:two-toggles "AEERH"
		     "AE erhalt"
		     :diamond
		     (copy-pushed)
		     nil  ;; that means: Release = Repush
		     
		     "AEWEG"
		     "AE weg"
		     :diamond
		     (share-pushed)
		     nil  ;; that means: Release = Repush
       )
      )
     )
     (:bottom)
    )
   :close-action '(hide-rohrdat-dialog)
)

;;- - - adapt Ok, Cancel, Help callbacks  - - - - - - - - - - - - - - - - - - -

(change_wid_property_f "ROHRDAT-BL-COMPLETE-PB"
		       :sensitive     :true
		       :push          '(rohr-aus-tabelle))

(change_wid_property_f "ROHRDAT-BL-CANCEL-PB"
		       :sensitive     :true
		       :push          '(cancel-pushed))

(change_wid_property_f "ROHRDAT-BL-HELP-PB"
		       :push          '(help-pushed))

(change_wid_property_f "ROHRDAT-FO"
		       :borderColor   ui::*HighlightColor*)

;;----- Add a button to the toolbox -------------------------------------------

(when (widget-id "TOOLBOX-COMMANDS-ROHRDATEI-TB")
  (remove_toolbox_button :label "Rohrdatei"))

(add_toolbox_button :label "Rohrdatei"
		    :action '(progn
			       (show-and-initialize-rohrdat-dialog)
			       (reset-toggle "TOOLBOX-COMMANDS-ROHRDATEI-TB")))


;;----- Widget Callback functions ---------------------------------------------

(defun show-and-initialize-rohrdat-dialog ()
  ;; initialize filename datafield
  (reset-toggle "ROHRDAT-OPTIONS-OPT-CONT-FILENAME-TB")
  (setq *rohrdat-filename* nil)
  (setq *rohrdat-filename* "rohr.dat")
  (update-toggle-data "ROHRDAT-OPTIONS" "FILENAME" nil 
		      :direct-value *rohrdat-filename*)
  ;; initialize Rohrdurchmesser  
  (reset-toggle "ROHRDAT-OPTIONS-OPT-CONT-ADURCH-TB")
; (setq *rohrdurchmesser* nil)
  (setq *rohrdurchmesser* 12)
  (update-toggle-data "ROHRDAT-OPTIONS" "ADURCH" nil 
		      :direct-value *rohrdurchmesser*)
  ;; initialize Wandstrke          
  (reset-toggle "ROHRDAT-OPTIONS-OPT-CONT-WANDST-TB")
; (setq *rohrwandstaerke* nil)
  (setq *rohrwandstaerke* 1)
  (update-toggle-data "ROHRDAT-OPTIONS" "WANDST" nil 
		      :direct-value *rohrwandstaerke*)
  ;; initialize Copy/Share Buttons
  (setq *rohrdat-wp-mode* :copy)
  (set-toggle "ROHRDAT-OPTIONS-OPT-CONT-AEERH-TB")
  (reset-toggle "ROHRDAT-OPTIONS-OPT-CONT-AEWEG-TB")
  ;; show Pipe Dialog
  (show-shell-menu-box "ROHRDAT" :shell-position '("TOOLBOX-DS"  ;; Reference Wid
						:bottomleft   ;; Attachment
						0             ;; x offset
						0))           ;; y offset
  )

(defun hide-rohrdat-dialog ()
  (hide-dialog "ROHRDAT")
  (put-buffer "cancel_all")
  (hide-file-browser :implicit nil)) 

;;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

(defun dateiname-toggle-pushed ()
  (set-toggle "ROHRDAT-OPTIONS-OPT-CONT-FILENAME-TB")
  (show-file-browser :delayed nil 
		     :shell-position '("ROHRDAT-DS" :bottomleft 130 -60)
		     :initialPattern "*.dat")
  (setq *rohrdat-filename* (read-string "Geben Sie den Dateinamen an, der die Rohrdaten enthlt"))
  (hide-file-browser :implicit nil)
  (reset-toggle "ROHRDAT-OPTIONS-OPT-CONT-FILENAME-TB")
  (update-toggle-data "ROHRDAT-OPTIONS" "FILENAME" nil 
		      :direct-value *rohrdat-filename*)
  (values))

(defun dateiname-return ()
  (if (is-toggle-set "ROHRDAT-OPTIONS-OPT-CONT-FILENAME-TB")
      ;; THEN
      (put-buffer (format nil "~S" (get_text_wid_value_f
				    "ROHRDAT-OPTIONS-OPT-CONT-FILENAME-TX")))
    ;; ELSE
    (progn
      (setq *rohrdat-filename* (get_text_wid_value_f "ROHRDAT-OPTIONS-OPT-CONT-FILENAME-TX"))
      (update-toggle-data "ROHRDAT-OPTIONS" "FILENAME" nil 
			  :direct-value *rohrdat-filename*))))

;;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

(defun rohrdurch-pushed ()
  (set-toggle "ROHRDAT-OPTIONS-OPT-CONT-ADURCH-TB")
  (setq *rohrdurchmesser* (read-length "Geben Sie den Rohrdurchmesser ein :"))
  (setq *rohrdurchmesser_halb* (/ *rohrdurchmesser* 2))
  (reset-toggle "ROHRDAT-OPTIONS-OPT-CONT-ADURCH-TB")
  (update-toggle-data "ROHRDAT-OPTIONS" "ADURCH" nil 
		      :direct-value *rohrdurchmesser*)
  (values))

(defun rohrdurch-return ()
  (if (is-toggle-set "ROHRDAT-OPTIONS-OPT-CONT-ADURCH-TB")
      ;; THEN
;      (put-buffer (format nil "~S" (get_text_wid_value_f
;				    "ROHRDAT-OPTIONS-OPT-CONT-ADURCH-TX")))
      (put-buffer (get_text_wid_value_f "ROHRDAT-OPTIONS-OPT-CONT-ADURCH-TX"))
    ;; ELSE
    (progn
      (setq *rohrdurchmesser* (read-from-string (get_text_wid_value_f "ROHRDAT-OPTIONS-OPT-CONT-ADURCH-TX")))
      (update-toggle-data "ROHRDAT-OPTIONS" "ADURCH" nil 
			  :direct-value *rohrdurchmesser*))))

;;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

(defun wandst-pushed ()
  (set-toggle "ROHRDAT-OPTIONS-OPT-CONT-WANDST-TB")
  (setq *rohrwandstaerke* (read-length "Geben Sie die Rohr-Wandstrke ein :"))
  (reset-toggle "ROHRDAT-OPTIONS-OPT-CONT-WANDST-TB")
  (update-toggle-data "ROHRDAT-OPTIONS" "WANDST" nil 
		      :direct-value *rohrwandstaerke*)
  (values))

(defun wandst-return ()
  (if (is-toggle-set "ROHRDAT-OPTIONS-OPT-CONT-WANDST-TB")
      ;; THEN
;      (put-buffer (format nil "~S" (get_text_wid_value_f
;				    "ROHRDAT-OPTIONS-OPT-CONT-WANDST-TX")))
      (put-buffer (get_text_wid_value_f "ROHRDAT-OPTIONS-OPT-CONT-WANDST-TX"))
    ;; ELSE
    (progn
      (setq *rohrwandstaerke* (read-from-string (get_text_wid_value_f "ROHRDAT-OPTIONS-OPT-CONT-WANDST-TX")))
      (update-toggle-data "ROHRDAT-OPTIONS" "WANDST" nil 
			  :direct-value *rohrwandstaerke*))))

;;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

(defun copy-pushed ()
  (setq *rohrdat-wp-mode* :copy)
  (reset-toggle "ROHRDAT-OPTIONS-OPT-CONT-AEWEG-TB"))

;;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	     
(defun share-pushed ()
  (setq *rohrdat-wp-mode* :share)
  (reset-toggle "ROHRDAT-OPTIONS-OPT-CONT-AEERH-TB"))
	
;;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

(defun cancel-pushed ()
  (hide-rohrdat-dialog))
	
(defun help-pushed ()
  (put-buffer "info :keyword \"lift\""))  ;; only one example ;-)

;;=============================================================================

